apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ prometheus_name }}
  name: {{ prometheus_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: OrderedReady
  replicas: {{ prometheus_replicas }}
  selector:
    matchLabels:
      name: {{ prometheus_name }}
  serviceName: {{ prometheus_name }}
  template:
    metadata:
      labels:
        name: {{ prometheus_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ prometheus_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ prometheus_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      initContainers:
      - args:
        - -c
        - |
{% if do_debugs %}
             set -x; \
{% endif %}
             sed "/external_labels:.*/ascrape_by: $REPLICA" /etc/prometheus.yml.tpl | \
                 sed "s|^scrape_by:|    scrape_by:|" >/etc/prometheus/prometheus.yml;
        command: [ /bin/sh ]
        env:
        - name: REPLICA
          valueFrom:
            fieldRef:
              fieldPath: metadata.name
        image: {{ (opsimages | json_query("[?name=='prometheus'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        name: configure
        volumeMounts:
        - mountPath: /etc/prometheus
          name: temp
          subPath: prometheus
        - mountPath: /etc/prometheus.yml.tpl
          name: config
          subPath: prometheus.yml
      containers:
      - args:
{% if do_debugs %}
        - --log.level=debug
{% else %}
        - --log.level=info
{% endif %}
        - --config.file=/etc/prometheus/prometheus.yml
{% if do_thanos %}
        - --storage.tsdb.max-block-duration=2h
        - --storage.tsdb.min-block-duration=2h
{% endif %}
        - --storage.tsdb.path=/prometheus
        - --storage.tsdb.retention.time={{ prometheus_retention }}
        - --web.external-url=https://{{ prometheus_fqdn }}
        - --web.console.libraries=/usr/share/prometheus/console_libraries
        - --web.console.templates=/usr/share/prometheus/consoles
{% if do_thanos %}
        - --web.enable-admin-api
        - --web.enable-lifecycle
{% endif %}
        env:
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='prometheus'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 20
{% else %}
          failureThreshold: 5
{% endif %}
          httpGet:
            path: /-/healthy
            port: 9090
          initialDelaySeconds: 30
          timeoutSeconds: 10
        name: prometheus
        ports:
        - containerPort: 9090
        readinessProbe:
          httpGet:
            path: /-/ready
            port: 9090
          initialDelaySeconds: 30
          timeoutSeconds: 5
        resources:
          limits:
            cpu: "{{ prometheus_cpu_limit }}"
            memory: "{{ prometheus_memory_limit }}"
          requests:
            cpu: "{{ prometheus_cpu_request }}"
            memory: "{{ prometheus_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 70
          initialDelaySeconds: 10
          periodSeconds: 15
          tcpSocket:
            port: 9090
{% endif %}
        volumeMounts:
        - mountPath: /etc/prometheus
          name: temp
          subPath: prometheus
        - mountPath: /prometheus
          name: data
        - mountPath: /etc/prometheus/rules.d
          name: rules
{% if do_thanos %}
      - args:
        - sidecar
        - --grpc-address=0.0.0.0:10901
        - --http-address=0.0.0.0:10902
{% if do_debugs %}
        - --log.level=debug
{% else %}
        - --log.level=info
{% endif %}
        - --objstore.config=$(OBJSTORE_CONFIG)
        - --prometheus.ready_timeout=10m
        - --prometheus.url=http://127.0.0.1:9090
        - --tsdb.path=/prometheus
        env:
        - name: OBJSTORE_CONFIG
          valueFrom:
            secretKeyRef:
              key: thanos.yaml
              name: {{ thanos_name }}-store
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='thanos'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 30
          httpGet:
            path: /-/healthy
            port: 10902
          periodSeconds: 30
        name: thanos
        ports:
        - containerPort: 10901
          name: grpc
        - containerPort: 10902
          name: http
        readinessProbe:
          failureThreshold: 20
          httpGet:
            path: /-/ready
            port: 10902
          periodSeconds: 5
        resources:
          limits:
            cpu: "{{ thanos_sidecar_cpu_limit }}"
            memory: "{{ thanos_sidecar_memory_limit }}"
          requests:
            cpu: "{{ thanos_sidecar_cpu_request }}"
            memory: "{{ thanos_sidecar_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /prometheus
          name: data
{% endif %}
{% if prometheus_do_lemon or prometheus_do_ldap %}
      - env:
        - name: AUTH_METHOD
{% if prometheus_do_lemon %}
          value: oidc
{% else %}
          value: ldap
{% endif %}
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
{% if prometheus_do_lemon %}
          value: /oauth2/callback
        - name: OIDC_CLIENT_ID
          value: prometheus
        - name: OIDC_CLIENT_SECRET
          valueFrom:
            secretKeyRef:
              key: prometheus-oauth2-secret
              name: {{ ldap_secret_name }}
        - name: OIDC_CRYPTO_SECRET
          valueFrom:
            secretKeyRef:
              key: oidc-crypto-secret
              name: {{ prometheus_name }}
        - name: OIDC_META_URL
          value: /.well-known/openid-configuration
        - name: OIDC_PORTAL
          value: {{ lemon_portal }}
        - name: OIDC_TOKEN_ENDPOINT_AUTH
          value: client_secret_basic
{% else %}
          value: ""
        - name: OIDC_CLIENT_ID
          value: ""
        - name: OIDC_CLIENT_SECRET
          value: ""
        - name: OIDC_CRYPTO_SECRET
          value: ""
        - name: OIDC_META_URL
          value: ""
        - name: OIDC_PORTAL
          value: ""
        - name: OIDC_TOKEN_ENDPOINT_AUTH
          value: ""
{% endif %}
        - name: OPENLDAP_BASE
{% if prometheus_do_lemon %}
          value: ""
        - name: OPENLDAP_BIND_DN_PREFIX
          value: ""
        - name: OPENLDAP_BIND_PW
          value: ""
        - name: OPENLDAP_DOMAIN
          value: ""
        - name: OPENLDAP_HOST
          value: ""
        - name: OPENLDAP_PORT
          value: ""
        - name: OPENLDAP_PROTO
          value: ""
        - name: OPENLDAP_USERS_OBJECTCLASS
          value: ""
        - name: PING_PATH
          value: /ping
{% else %}
          valueFrom:
            secretKeyRef:
              key: directory-root
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_BIND_DN_PREFIX
          value: cn=authproxy,ou=services
        - name: OPENLDAP_BIND_PW
          valueFrom:
            secretKeyRef:
              key: authproxy-password
              name: {{ ldap_secret_name }}
        - name: OPENLDAP_DOMAIN
          value: {{ root_domain }}
        - name: OPENLDAP_HOST
{% if ldaps_address | default(False) %}
          value: {{ ldaps_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldaps_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldaps
{% else %}
          value: {{ ldap_address | urlsplit('hostname') }}
        - name: OPENLDAP_PORT
          value: "{{ ldap_address | urlsplit('port') }}"
        - name: OPENLDAP_PROTO
          value: ldap
{% endif %}
        - name: OPENLDAP_USERS_OBJECTCLASS
{% if prometheus_do_fusion %}
          value: gosaAccount
{% else %}
          value: {{ prometheus_ldap_user_objectclass }}
{% endif %}
        - name: PING_PATH
          value: ""
{% endif %}
        - name: PROXY_BACKEND_HOST
          value: 127.0.0.1
        - name: PROXY_BACKEND_PORT
          value: "9090"
        - name: PROXY_BACKEND_PROTO
          value: http
        - name: PROXY_HTTP_PORT
          value: "8080"
        - name: PROXY_PROTO
          value: http
        - name: PROXY_SERVER_NAME
          value: {{ prometheus_fqdn }}
        - name: PUBLIC_PROTO
          value: https
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='authproxy'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 30
          initialDelaySeconds: 30
          httpGet:
            httpHeaders:
            - name: Host
{% if prometheus_do_lemon %}
              value: {{ prometheus_fqdn }}
            path: /ping/
{% else %}
              value: stats
            path: /
{% endif %}
            port: 8080
          periodSeconds: 20
          timeoutSeconds: 8
        name: authproxy
        ports:
        - containerPort: 8080
        readinessProbe:
          initialDelaySeconds: 5
          httpGet:
            httpHeaders:
            - name: Host
{% if prometheus_do_lemon %}
              value: {{ prometheus_fqdn }}
            path: /ping/
{% else %}
              value: stats
            path: /
{% endif %}
            port: 8080
          periodSeconds: 20
          timeoutSeconds: 5
        resources:
          limits:
            cpu: "{{ authproxy_cpu_limit }}"
            memory: "{{ authproxy_memory_limit }}"
          requests:
            cpu: "{{ authproxy_cpu_request }}"
            memory: "{{ authproxy_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
{% if (prometheus_do_ldap or prometheus_do_lemon) and k8s_flavor == 'kubernetes' %}
        - mountPath: /certs
          name: pkiconf
{% endif %}
        - mountPath: /etc/apache2/sites-enabled
          name: temp
          subPath: apache
        - mountPath: /etc/ldap
          name: ldapconf
        - mountPath: /usr/local/share/ca-certificates
          name: temp
          subPath: ca-certificates
        - mountPath: /etc/ssl/certs
          name: temp
          subPath: certs
        - mountPath: /usr/share/ca-certificates
          name: temp
          subPath: empty
{% if do_exporters %}
      - args:
{% if do_debugs %}
        - --log.level=debug
{% endif %}
        - --scrape_uri
        - http://stats:8080/server-status
        - --telemetry.address=:9113
        image: {{ (opsimages | json_query("[?name=='httpexporter'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 30
          httpGet:
            path: /
            port: 9113
          initialDelaySeconds: 30
          periodSeconds: 20
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9113
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
{% endif %}
{% elif prometheus_do_oc %}
      - args:
        - -provider=openshift
        - -proxy-prefix=/oauth2
{% if oc_api_fqdn | default(False) %}
        - -login-url=https://{{ oc_api_fqdn }}/oauth/authorize
        - -redeem-url=https://kubernetes.default.svc/oauth/token
{% endif %}
        - -https-address=:8443
        - -http-address=
        - -email-domain=*
        - -upstream=http://127.0.0.1:9090
        - -tls-cert=/etc/tls/private/tls.crt
        - -tls-key=/etc/tls/private/tls.key
        - -client-id=system:serviceaccount:{{ namespace }}:{{ prometheus_name }}
        - -client-secret-file=/var/run/secrets/kubernetes.io/serviceaccount/token
        - -cookie-secret-file=/etc/proxy/secrets/session_secret
        - -cookie-refresh=0
        - -cookie-expire=24h0m0s
        - -cookie-name=_oauth2_prometheus
        - -skip-auth-regex=^/oauth/healthz
        image: {{ (opsimages | json_query("[?name=='oauthproxy'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
          failureThreshold: 30
          initialDelaySeconds: 30
          tcpSocket:
            port: 8443
          periodSeconds: 20
          timeoutSeconds: 8
        name: authproxy
        ports:
        - containerPort: 8443
        readinessProbe:
          initialDelaySeconds: 5
          httpGet:
            path: /oauth/healthz
            port: 8443
            scheme: HTTPS
          periodSeconds: 20
          timeoutSeconds: 5
        resources:
          limits:
            cpu: "{{ oauthproxy_cpu_limit }}"
            memory: "{{ oauthproxy_memory_limit }}"
          requests:
            cpu: "{{ oauthproxy_cpu_request }}"
            memory: "{{ oauthproxy_memory_request }}"
        securityContext:
          allowPrivilegeEscalation: false
        volumeMounts:
        - mountPath: /etc/tls/private
          name: tls
        - mountPath: /etc/proxy/secrets
          name: session
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-monitoring
{% endif %}
{% if k8s_flavor == 'kubernetes' or rwo_needs_fsgroup | default(False) %}
      securityContext:
{% if rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% if k8s_flavor == 'kubernetes' %}
        runAsUser: {{ k8s_unprivileged_userid }}
{% endif %}
{% else %}
      securityContext: {}
{% endif %}
      serviceAccountName: {{ prometheus_name }}
      terminationGracePeriodSeconds: 120
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ prometheus_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
      volumes:
      - configMap:
          name: {{ prometheus_name }}
        name: config
      - name: rules
        projected:
          sources:
{% for rule_file in prometheus_rules %}
{% if (do_thanos and do_thanos_rule and rule_file is match('thanos')) or not do_thanos_rule %}
          - configMap:
              items:
              - key: {{ rule_file }}.yaml
                path: {{ rule_file }}.yaml
              name: {{ prometheus_name }}-rule-{{ rule_file | lower | regex_replace('[^a-z0-9]', '') }}
{% endif %}
{% endfor %}
{% if notify_outside_business_hours and not (do_thanos and do_thanos_rule) %}
          - configMap:
              items:
              - key: nonworkinghour.yaml
                path: nonworkinghour.yaml
              name: {{ prometheus_name }}-rule-nwh
{% endif %}
      - emptyDir: {}
        name: temp
{% if prometheus_do_lemon or prometheus_do_ldap %}
      - configMap:
          name: {{ ldap_name | default('ldap') }}-config
        name: ldapconf
{% if (prometheus_do_ldap or prometheus_do_lemon) and k8s_flavor == 'kubernetes' %}
      - name: pkiconf
        projected:
          sources:
          - secret:
              items:
              - key: ca.crt
                path: ca.crt
{% if directory_tls_provider | default(tls_provider) == 'cert-manager' %}
              name: certmanager-{{ certmanager_ca_name | default(cr_name) }}-root-ca
{% else %}
              name: {{ internal_ca_name | default(cr_name) }}-root-ca
{% endif %}
{% endif %}
{% elif prometheus_do_oc %}
      - name: session
        secret:
          secretName: {{ prometheus_name }}-oauth
      - name: tls
        secret:
          secretName: {{ prometheus_name }}-cert
{% endif %}
  updateStrategy:
    type: RollingUpdate
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: "{{ prometheus_data_capacity }}"
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
